/*
----------------------------------------
	AUTOLOAD.C: MicroEMACS 3.10
----------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "estruct.h"
#include "etype.h"
#include "edef.h"
#include "elang.h"

/*
========================================
	RCS id ̐ݒ
========================================
*/

__asm("	dc.b	'$Id: autoload.c,v 1.2.1.3 1995/01/21 11:20:40 sharl Exp $'\n""	even\n");

/*
========================================
	gp֐̒`
========================================
*/

static void addautolist(char *, char *);
static ALOAD *searchautolist(char *);

/*
========================================
	gpϐ̒`
========================================
*/

static __pcr__ ALOAD *autolist = 0;

/*
========================================
	I[g[hXg
========================================
*/

static inline ALOAD *searchautolist(char *macro)
{
	ALOAD *ptr;

	for (ptr = autolist; ptr; ptr = ptr->next) {
		if (*ptr->macro == *macro && !strcmp(ptr->macro + 1, macro + 1))
			return ptr;
	}
	return 0;
}

/*
----------------------------------------
	I[g[hw
----------------------------------------
*/

int autoload(int f, int n)
{
	int status;
	char *mac;
	char file[NFILEN], outseq[NSTRING], bufn[NBUFN];

	strcpy(outseq, KTEX249);
	mac = complete(outseq, 0, 0, CMP_MACRO, NBUFN - 2);
	if (mac == 0)
		return FALSE;
	strcat(outseq, mac);
	strcat(outseq, " ");
	his_disable();
	status = mlreply(outseq, file, NFILEN);
	if (status != TRUE)
		return status;
	sprintf(bufn, "[%s]", mac);
	if (bfind(bufn, FALSE, 0) == 0) {
		BUFFER *bp;

		bp = bfind(bufn, TRUE, BFINVS);
		bp->b_active = FALSE;
		addautolist(mac, file);
	}
	return TRUE;
}

/*
========================================
	I[g[hXgւ̒ǉ
========================================
*/

static void addautolist(char *macro, char *file)
{
	ALOAD *ptr;

	ptr = searchautolist(macro);
	if (ptr == 0) {
		ptr = (ALOAD *) malloc(sizeof(ALOAD));
		ptr->next = autolist;
		autolist = ptr;
	}
	strcpy(ptr->macro, macro);
	strcpy(ptr->file, file);
}

/*
========================================
	[hyюs
========================================
*/

int loadexec(char *macro, int *ecode)
{
	ALOAD *aload;

	*ecode = 0;
	aload = searchautolist(macro);
	if (aload) {
		int status, savearg;
		char *fspec;

		fspec = flook(aload->file, TRUE);
		if (fspec == 0) {
			if (clexec == FALSE)
				mlwrite(KTEX214, aload->file);
			return FALSE;
		}
		savearg = cmdarg;
		status = dofile(fspec);
		cmdarg = savearg;
		return status;
	}
	*ecode = -1;
	return FALSE;
}
