/*
----------------------------------------
	ETYPE.H: MicroEMACS 3.10
----------------------------------------
*/

/*
----------------------------------------
	RCS id : $Id: etype.h,v 1.5.1.23 1996/10/13 07:06:52 sharl Exp $
----------------------------------------
*/

/*
----------------------------------------
	֐̃vg^Cv錾
----------------------------------------
*/

BUFFER *bfind(char *, int, int);
BUFFER *getcbuf(char *, char *, int);
#ifndef MINES
BUFFER *getdefb(void);
#endif
KEYTAB *getbind(int);
LINE *lalloc(int);
LINE *lrealloc(LINE *, int);
NBIND *com_in_word_set(const char *);
NBIND *getname2(char *);
char *keyword_in_word_set(char *, int);
UCWORD *c_in_word_set(char *, int);
UDIRS *dirs_in_word_set(char *, int);
UVAR *create_var(const char *);
UVAR *var_in_word_set(const char *);
UENVAR *env_in_word_set(const char *);
UFUNC *func_in_word_set(char *, int);
WINDOW *wpopup(void);
char *add_slash_if(char *);
char *complete(char *, char *, char *, int, int);
char *cv_bslash_slash(char *);
char *delete_slash_if(char *);
char *dired_get_target_filename(LINE *);
char *dosgetenv(char *);
char *envval(int);
char *ej_word (const char *);
char *expand_tild (char *name);
char *flook(char *, int);
char *funval(int);
char *getctext(void);
char *getffile(char *, int);
char *getnfile(int);
char *getreg(void);
char *getval(char *);
char *getwd(char *);
char *getword(void);
char *gtdirname(char *);
char *gtfilename(char *);
char *gtenv(char *);
char *gtusr(char *);
char *int_asc(int);
char *makename(char *, char *);
char *namval(int);
char *singleexpwild(char *);
char *termstr(void);
char *timeset(void);
char *token(char *, char *, int);
char *transbind(char *);
char *getname(char *);
int H68beep(void);
int H68close(void);
int H68cres(char *);
int H68getc(void);
int H68move(short, short);
int H68open(void);
int addline(BUFFER *, char *);
int ankforwchar(int, int);
int anycb(void);
int apendnext(int, int);
int apro(int, int);
int asc_int(char *);
int asm_insaster(int, int);
int asm_inscolon(int, int);
int asm_inssemi(int, int);
int asm_newline(int, int);
int autoload(int, int);
int backchar(int, int);
int backdel(int, int);
int backhunt(int, int);
int backline(int, int);
int backpage(int, int);
int backsearch(int, int);
int backword(int, int);
int bad_mode(void);
int bclear(BUFFER *);
int bell(int, int);
int bindtokey(int, int);
int bindtoxf1key(int, int);
int bindtoxf2key(int, int);
int bindtoxf3key(int, int);
int bindtoxf4key(int, int);
int bindtoxf5key(int, int);
int c_backdel(int, int);
int c_complete(int, int);
int c_forwdel(int, int);
int c_insbrace(int, int);
int c_insbracket(int, int);
int c_insparen(int, int);
int c_inspound(int, int);
int c_instab(int, int);
int c_newline(int, int);
int capsreverse(int, int);
int capword(int, int);
int cd(char *);
int cex(int, int);
int change_key(int);
int check_over(void);
int check_wrap(void);
int cinsert(void);
int clrmes(int, int);
int compareb(int, int);
int comparel(int, int);
int copyline(int, int);
int copyregion(int, int);
int countbyte(int);
int crypt(char *, int);
int ctlxe(int, int);
int ctlxlp(int, int);
int ctlxrp(int, int);
int ctrlg(int, int);
int deblank(int, int);
int delbword(int, int);
int delfword(int, int);
int delgmode(int, int);
int delkbuf(int, int);
int delmode(int, int);
int delwind(int, int);
int desbind(int, int);
int desfunc(int, int);
int deskey(int, int);
int desvars(int, int);
int detabl(int, int);
int detabr(int, int);
int dired(int, int);
int dispvar(int, int);
int do_dired_backline(int, int);
int do_dired_cancel_all(int, int);
int do_dired_cd(int, int);
int do_dired_cp(int, int);
int do_dired_drop_mark(int, int);
int do_dired_forwline(int, int);
int do_dired_list(int, int);
int do_dired_mark(int, int);
int do_dired_mark_all(int, int);
int do_dired_mark_back(int, int);
int do_dired_mark_ext(int, int);
int do_dired_mv(int, int);
int do_dired_rb(int, int);
int do_dired_rm(int, int);
#ifndef MINES
int do_dired_trash(int, int);
int do_empty_trash(int, int);
#endif
int dobuf(BUFFER *);
int dofile(char *);
int dossetenv(int, int);
int dupline(int, int);
int ectoc(int);
int endword(int, int);
int enlargewind(int, int);
int entabl(int, int);
int entabr(int, int);
int eq(char, char);
int esleep(int, int);
int execbuf(int, int);
int execcmd(int, int);
int execfile(int, int);
int exechook(char *);
int execkey(KEYTAB *, int, int);
int execnbind(NBIND *, int, int);
int execprg(int, int);
int execproc(int, int);
int execprog(char *, int);
int exgctrlprefix(int, int);
int expandp(char *, char *, int);
int expwild(char *, int);
int fexist(char *);
int ffclose(void);
int ffwriteline(char *, int);
int ffreadline(LINE **, int *);
int ffgetline (int *);
int ffropen(char *);
int ffsize(void);
int ffwopen(char *, int);
int file_complete(int, int );
int filefind(int, int);
int filename(int, int);
int fileread(int, int);
int filesave(int, int);
int filewrite(int, int);
int fillpara(int, int);
int filter(int, int);
int find_dired_curfile(int, int);
int find_dired_files(int, int);
int findvar(char *, VDESC *, int);
int fisearch(int, int);
int fmatch(char);
int fnclabel(int, int);
int fontreset(int, int);
int forwbreakok(int);
int forwchar(int, int);
int forwdel(int, int);
int forwhunt(int, int);
int forwline(int, int);
int forwpage(int, int);
int forwsearch(int, int);
int forwword(int, int);
int getccol(int);
int getcline(void);
int getcmd(void);
int getfence(int, int);
int getfile(char *);
#ifndef MINES
int getgoal(LINE *, int);
#endif
int getkey(void);
#ifndef MINES
int getregion(REGION *, int, int);
#endif
int getstring(char *, char *, int, int);
int gettyp(char *);
int getwpos(void);
int gotobeol(int, int);
int gotobob(int, int);
int gotobol(int, int);
int gotobop(int, int);
int gotoeob(int, int);
int gotoeol(int, int);
int gotoeop(int, int);
int gotoline(int, int);
int gotomark(int, int);
int gotomultimarkf(int, int);
int gotomultimarkr(int, int);
int hantozenword(int, int);
int help(int, int);
int indent(int, int);
int insbrace(int, int);
int insfile(int, int);
int inspound(void);
int insspace(int, int);
int inword(void);
int isignoreext(char *);
int isbkupsuf(char *);
int istring(int, int);
int itime(int, int);
int ivar(int, int);
int justonespc(int, int);
int keyword_complete(int, int);
int kflush(int, int);
int killbuffer(int, int);
int killline(int, int);
int killpara(int, int);
int killregion(int, int);
int killtext(int, int);
int kinsert(char);
int latex_abstruct(int, int);
int latex_array(int, int);
int latex_center(int, int);
int latex_chapter(int, int);
int latex_cite(int, int);
int latex_closeblock(int, int);
int latex_complete(int, int);
int latex_description(int, int);
int latex_document(int, int);
int latex_enumerate(int, int);
int latex_eqnarray(int, int);
int latex_equation(int, int);
int latex_example(int, int);
int latex_figure(int, int);
int latex_footnote(int, int);
int latex_insbegin(int, int);
int latex_item(int, int);
int latex_itemize(int, int);
int latex_label(int, int);
int latex_makeenv(int, int);
int latex_mathmode(int, int);
int latex_minipage(int, int);
int latex_picture(int, int);
int latex_quotation(int, int);
int latex_quote(int, int);
int latex_ref(int, int);
int latex_section(int, int);
int latex_sloppypar(int, int);
int latex_table(int, int);
int latex_tabular(int, int);
int latex_titlepage(int, int);
int latex_uplist(int, int);
int latex_verb(int, int);
int latex_verbatim(int, int);
int latex_verse(int, int);
int ldelete(int, int);
int linsert(int, char);
int linstr(char *);
int listbuffers(int, int);
int lnewline(void);
int loadcfont(int, int);
int loadcfont_6x12(int, int);
int loadcfont_h(int, int);
int loadempdata(int, int);
int loadexec(char *, int *);
int loadfont(int, int);
int loadfont_6x12(int, int);
int loadfont_h(int, int);
int lookupword (int, int);
int lover(char *);
int lowerregion(int, int);
int lowerword(int, int);
int lowrite(char);
int macarg(char *);
int macrotokey(int, int);
int makebuflist(int, int);
int marknum(LINE *);
int meexit(int);
int meta(int, int);
int mlyesno(char *);
int moreheap(long size);
int movemdown(int, int);
int movemup(int, int);
int mregdown(int, int);
int mregup(int, int);
int mvdnwind(int, int);
int mvupwind(int, int);
int name_check(char *);
int name_complete(int comptype);
int namebuffer(int, int);
int namedcmd(int, int);
int narrow(int, int);
int newline(int, int);
int newsize(int, int);
int newwidth(int, int);
int nextarg(char *, char *, int, int);
int nextbuffer(int, int);
int nextdown(int, int);
int nextup(int, int);
int nextwind(int, int);
int nullproc(int, int);
int onlywind(int, int);
int openline(int, int);
int openmenu(int, int);
int ovstring(int, int);
int pipecmd(int, int);
int popd(int, int);
int prevwind(int, int);
int pushd(int, int);
int putctext(char *);
int putline(char *);
int qreplace(int, int);
int quickexit(int, int);
int quit(int, int);
int quote(int, int);
int rdonly(void);
int readin(int, int, char *);
int recoverlayout(int, int);
int reeat(int);
int refresh(int, int);
int reglines(int, int);
int remmark(int, int);
int reposition(int, int);
int resetrpat(int, int);
int resize(int, int);
int resterr(void);
int restwnd(int, int);
int risearch(int, int);
int savelayout(int, int);
int savemodified(int, int);
int savewnd(int, int);
int scanner(char *, int, int);
int search_end_forw(void);
int setargv(int);
int setccol(int);
int setekey(int, int);
int setfillcol(int, int);
int setgmode(int, int);
int setkey(KEYTAB *, int, char *);
int setmark(int, int);
int setmod(int, int);
int setmultimark(int, int);
int setvar(int, int);
int showcpos(int, int);
int shrinkwind(int, int);
int silentexecprg(int, int);
int sindex(char *, char *);
int spal(char *);
int spal2(char *);
int spawn(int, int);
int spawncli(int, int);
int splitwind(int, int);
int sreplace(int, int);
int startup(char *);
int stock(char *);
int stol(char *);
int storeproc(int, int);
int svar(VDESC *, char *);
int swapmark(int, int);
int swbuffer(BUFFER *, int);
int swlinenum(int, int);
#ifndef MINES
int swzcursor(int, int);
#endif
int tab(int, int);
int tex_insbrace(int, int);
int tex_insbraces(int, int);
int tex_insbracket(int, int);
int tex_insdollar(int, int);
int tex_insparen(int, int);
int tex_insquote(int, int);
int tex_termpara(int, int);
int tgetc(void);
int togglecr(int, int);
int toggleover(int, int);
int togglescrollspeed(int, int);
int toggletabdisp(int, int);
int togglezenspc(int, int);
int togglewrap(int, int);
int toggleunix(int, int);
int triml(int, int);
int trimr(int, int);
int turnofffunckey(int, int);
int turnonfunckey(int, int);
int twiddle(int, int);
int typahead(void);
int unarg(int, int);
int unbindkey(int, int);
int uneat(void);
int unmark(int, int);
int update(int);
int upperregion(int, int);
int upperword(int, int);
int upscreen(int, int);
int usebuffer(int, int);
int veremacs(int, int);
int view_dired_curfile(int, int);
int view_dired_files(int, int);
int viewfile(int, int);
int wcom(int, int);
int widen(int, int);
int wordcount(int, int);
int wrapword(int, int);
int writemsg(int, int);
int writeout(char *, int);
int wshell(int, int);
int yank(int, int);
int zaptochar(int, int);
int zentohanword(int, int);
int zotbuf(BUFFER *);
void H68clear(void);
#ifndef MINES
void TXcurof(void);
void TXcuron(void);
#endif
void adj_ins_mode(void);
void cmdstr(int, char *);
void cmdstr2(int, char *);
int comp_general(char *, int *, int);
void comp_variable(char *, int *);
void copyinf_win_to_buf(WINDOW *, BUFFER *);
void copyinf_buf_to_win(BUFFER *, WINDOW *);
void cwin_close(void);
void cwin_down(void);
void cwin_rolldown(void);
void cwin_rollup(void);
void cwin_up(void);
#ifndef MINES
void disp_cross_cur(void);
#endif
void disable_int(void);
void disable_print(void);
void enable_int(void);
void enable_print(void);
void expname(char *, char *);
void f_set_emacs(void);
void f_set_shell(void);
void getpath(char *, char *);
void his_enable(BUFFER *);
void his_disable(void);
void his_forward(LEDIT *, int);
void his_backward(LEDIT *, int);
void his_sc_forward(LEDIT *, int);
void his_sc_backward(LEDIT *, int);
void his_shortcut(LEDIT *, char *);
void his_regist(LEDIT *);
void include_fep_mode(int);
void intercept(void(*)(int), void(*)(void));
void intercept_end(void);
void kdelete(void);
void keyinit(void);
void lchange(int);
void lfree(LINE *);
void init_com_in_word_set(void);
void init_env_in_word_set(void);
void makelit(char *);
void mcclear(void);
void mlinit(void);
void mlupdate(void);
void mlmove(int);
void mlmovecursor(int);
int mlgetcursor(void);
void mlerase(void);
void mldeltoeol(void);
void mlforce(char *);
void mlout(int);
void mlwrite(char *, ...);
void movecursor(int, int);
void normalfont2cfont(char *, char *, int);
void ochar(int);
void oupdate(void);
void outstring(char *);
void outchar(int);
void outupdate(void);
void setjtable(char *);
void unqname(char *);
void upmode(void);
void upwind(void);
void varinit(void);
void vtinit(void);
void vttidy(void);
void warnfunc(char *);
void winbob(BUFFER *);
