*
*	Public Domain Software
*
*
*	Written by Masatoshi Yoshizawa (Yoz.) for GAPO jstevie Human68k
*	Added abort trap by Sawayanagi Yosirou <willow@saru.cc.u-tokyo.ac.jp>
*	1992.02.11 little modified by Y.Ogawa(GAPO) 
*	1992.02.23 little modified for MicroEMACS by SALT
*	1994.03.06 little modified by Sharl
*

	.text
*****************************************
* void hentrap(int flag, void (*handle_func)(int))
* int flag  0 --- hentrap hook start.
*          -1 --- hentrap hook end.
* void (*handle_func)(int)
*   when fep on/off call this function
*****************************************
_hentrap::
	tst.l	4(sp)
	beq	hentrap0

	move.l	8(sp),fep_handle_func

	clr.l	-(sp)
	pea	1.w
	dc.w	$ff22		* KNJCTRL(1,0)
	addq.w	#8,sp

	clr.l	henflag

	pea	hentrapmain(pc)
	move.w	#$ff18,-(sp)
	dc.w	$ff25		* intvcs
	move.l	d0,oldvect

	pea	aborthentrap(pc)
	move.w	#$fff2,-(sp)
	dc.w	$ff25		* intvcs
	move.l	d0,abortvect
	lea	12(sp),sp

	rts

hentrap0:
	clr.l	fep_handle_func
	move.l	abortvect(pc),-(sp)
	move.w	#$fff2,-(sp)
	dc.w	$ff25		* intvcs
	move.l	oldvect(pc),-(sp)
	move.w	#$ff18,-(sp)
	dc.w	$ff25		* intvcs
	lea	12(sp),sp
	rts

*************************************
* int iskmode (void)
* return value
*    0  --- ask henkanmode off.
*    -1 --- ask henkanmode on.
*************************************
_iskmode::
	move.l	henflag(pc),d0
	rts

hentrapmain:
	move.w	(A6),D0
	beq	henopen		* mode window open
	cmp.w	#3,D0
	beq	henclose	* mode window close
hencont:
 ifdef __MC68030__
 	jmp	([oldvect.w,pc])
 else
	move.l	oldvect(pc),A0
	jmp	(A0)
 endif

henopen:
	move.l	#-1,henflag
	bra	henhandle

henclose:
	clr.l	henflag
*	bra	henhandle

henhandle:
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	fep_handle_func(pc),d0
	beq	henhandle_end
	movea.l	d0,a0
	move.l	henflag(pc),-(sp)
	jsr	(a0)
	addq.w	#4,sp
henhandle_end:
	movem.l	(sp)+,d0-d7/a0-a6
	bra	hencont

aborthentrap:
	bsr	hentrap0
 ifdef __MC68030__
 	jmp	([abortvect.w,pc])
 else
	move.l	abortvect(pc),a0
	jmp	(a0)
 endif

henflag:
	dc.l	0
oldvect:
	dc.l	0
abortvect:
	dc.l	0
fep_handle_func:
	dc.l	0

	.end
