/*
 * idx.h
 * Copyright (C) 1991-1993 candy
 * $Id: idx.h,v 1.2.1.1 1996/02/20 13:15:27 sharl Exp $
 */
#ifndef __IDX_H
#define __IDX_H
/*
 * dyna.h Kv
 */
#ifndef __DYNA_H
#include "dyna.h"
#endif /* !__DYNA_H */

/*
 * ^CgƂ̃ItZbgێB
 */
#define ENTMORE 8192
struct ENTRY { /* ^CgGg\ */
	long offset;
	char *title;
};

typedef struct STRUCT_DYNA(struct ENTRY *) ENTLIST;

extern void * F_DYNA_IZ(ENTLIST *lp);
extern void list_bye(ENTLIST *lp);
extern struct ENTRY * ent_new_set(ENTLIST *lp, const char *title, long offset);
extern struct ENTRY ** list_sort(ENTLIST *lp);


/*
 * CfNXt@C̃wb_
 */
struct head {
	long count; /* Gg */
	long tsize; /* ̈oCg */
};

/*
 * ^CgƂ̃ItZbgێB
 */
struct ent { /* ^CgGg\ */
	long offset;
	union {
		long tidx;
		char *title;
	} u;
};

typedef struct ENTPOOL {
	long count; /* ^Cg̑ */ 
	struct ent **ls; /* ^CgGg\̂ւ̃|C^̔z̃AhX */
	struct ent *lsbuf; /* Gg͎O */
	char *tbuf; /* ^CgO */
} ENTPOOL;

extern int lp_read(ENTPOOL *lp, FILE *fp);
extern int lp_search(ENTPOOL *lp, const char *title);

#endif /* !__IDX_H */
