/*
----------------------------------------
	EDEF.H: MicroEMACS 3.10
----------------------------------------
*/

/*
----------------------------------------
	RCS id : $Id: edef.h,v 1.10.1.59 1996/10/26 21:26:38 sharl Exp $
----------------------------------------
*/

/*
----------------------------------------
	main.c ϐ̏lݒ
----------------------------------------
*/

#ifdef	maindef

BUFFER *bheadp, *blistp, *bcompp, *curbp;
BUFFER *bdiredp, *bdmarkp;
BUFFER *bhisexecp, *bhisenvp, *bhiscmdp, *bhissearchp;
BUFFER *bhisargp, *bhisdebugp;
BUFFER *bhiscmpbufp, *bhiscmpcp, *bhiscmpcomp, *bhiscmpfnamep;
BUFFER *bhiscmpgenp, *bhiscmpmacp, *bhiscmpmodep;
BUFFER *bhiscmpvarp, *bhiscmpdnamep;
#ifndef MINES
BUFFER *bdictp, *bhiscmplatexp;
#endif
KEYTAB *keytab[NKEYMAPS];
LINE *matchline;
MC mcpat[NPAT], tapcm[NPAT];
RMC rmcpat[NPAT];
UVAR *uv_head, *uv_tail;
VIDEO **vscreen;
WINDOW *curwp, *wheadp;
char **ex_agv, **pr_agv, **func_name;
#ifndef MINES
char palstr[49], palstr2[49];
#endif
char sres[6], comp_gene[NFILEN], comp_c[NFILEN];
char emacsdir[NFILEN];
char current_dir[NFILEN];
#ifndef MINES
char comp_latex[NFILEN], latex_env[NFILEN], help_load_path[NFILEN];
#endif
char ifilename[NFILEN];
char readbuf[NSTRING];
char golabel[NPAT], lastmesg[NSTRING];
#ifndef MINES
char trash[NFILEN];
#endif
char dired_current_dir[NFILEN];
char outline[NSTRING], pat[NPAT], rpat[NPAT];
char tap[NPAT], system_temp[NSTRING];
char simple_backup_suffix[NFILEN];
char wrapindenthead[NIHEAD];
char bufhook[NBUFN], inshook[NBUFN];
char readhook[NBUFN], wraphook[NBUFN], writehook[NBUFN];
char exithook[NBUFN], ifilehook[NBUFN];
#ifndef MINES
char cmdhook[NBUFN], exbhook[NBUFN], windhook[NBUFN];
#endif
int *kbdptr, curcol, curgoal, currow, dired_mark_num, sccurcol;
int malloc_sbrk_unused, malloc_sbrk_used, thisflag;
int matchlen, matchoff, mlenold;
int sccurline, kbdm[NKBDM], lastflag;
int malloc_rating, malloc_old_rating;
#ifndef MINES
int xpos, ypos;
#endif
int ex_agc, pr_agc;
int nfuncs, ttrow, ttcol;
int taboff, vtcol, vtrow;
int updinsf;
int LEDmode;
long *lndrv_info;
char *sysroot;

KILL *kbufh = 0;

char *execstr = 0;
char *fline = 0;
char *lastptr = 0;
char *patmatch = 0;

#ifndef MINES
char dired_cp_cmd[NDCMD] = "cp.x -fp";
char dired_ls_cmd[NDCMD] = "ls.x -laLV";
char dired_mv_cmd[NDCMD] = "mv.x -f";
char dired_rm_cmd[NDCMD] = "rm.x -f";
#else
char dired_cp_cmd[] = "cp.x -fp";
char dired_ls_cmd[] = "ls.x -laLV";
char dired_mv_cmd[] = "mv.x -f";
char dired_rm_cmd[] = "rm.x -f";
#endif

#ifndef MINES
char std_dict_path[NSTRING] = "/usr/dict;/usr/local/dict";
#endif

char slash = '/';

#ifndef MINES
char backnonbreakchar[NCHKSTR]
#else
char backnonbreakchar[]
#endif
  = "Legikmoqsuwy";
#ifndef MINES
char fornonbreakchar[NCHKSTR]
#else
char fornonbreakchar[]
#endif
  = "ABCDHIJKMjlnprtvxz[`c"
    "@BDFHb";
char dostail[NCHKSTR] = "CONFIG.SYS;.BAT;.ENV;ENVIRON";
char ignoreext[NSTRING]
  = "o;a;x;z;r;bak;dvi;pic;mag;gif;jpg;cam;mpg;avi;mov;mdx;pdx;zmd;zpd;pcm;mid;rcp;"
  	"bfd;lzh;zoo;arc;zip;ar;tar;taz;tgz;lgz;agz;rgz;xgz";
char mlform[NMLFORM]
  = "?#?*?n ?dw ?dM ?dD ?T ?l[?r%%]?w (?m) ?=?= ?b ?=?=?F";
#ifndef MINES
char menu_title[NMTITLE]
  = "no title";
char menu_exit[NMKEY]
  = "^[;^G";
char menu_select[NMKEY]
  = "^M";
char texbquote[NTQUOTE]
  = "\t\' ";
#endif
#ifndef MINES
char wrapitem[NCHKSTR]
#else
char wrapitem[]
#endif
  = "E恖";
#ifndef MINES
char wrapindentitem[NIHEAD]
#else
char wrapindentitem[]
#endif
  = "  ";

int _dump_flag = 0;

int *kbdend = &kbdm[0];
int abortc = CTRL | 'G';
#ifndef MINES
int addeof = FALSE;
#endif
int asm_indent = TRUE;
int breakmode = 0;
int cbufdir = TRUE;
#ifndef MINES
int chigh = TRUE;
int cbold = FALSE;
#endif
int clexec = FALSE;
int cmdarg = 1;
#ifndef MINES
int cmdcol = 3;
#endif
int cmdstatus = TRUE;
#ifndef MINES
int cmdzencol = 1;
int colvis = FALSE;
int comp_sort = TRUE;
int comp_sort_dir = TRUE;
int comp_sort_ext = FALSE;
int comp_sort_ignore_case = FALSE;
int crcol = 1;
#endif
int dateflag = FALSE;
int debug_system = 0;
int density = 0;
#ifndef MINES
int diagflag = FALSE;
#endif
int dired_cd_flag = TRUE;
int dired_ls_name_pos = 35;
int discmd = TRUE;
int disinp = TRUE;
int disnum = FALSE;
int dispcr = TRUE;
int distab = FALSE;
int diszen = FALSE;
#ifndef MINES
int dselcol = 1;
int edpage = TRUE;
#endif
int eexitflag = FALSE;
#ifndef MINES
int empcol = 0x83;
int ena_hscroll = 0;
short ena_wait_vdisp = 0;
int ena_zcursor = 0;
int english = FALSE;
#endif
int envram = 0;
int execlevel = 0;
int executinghook = FALSE;
#ifndef MINES
int fepctrl = TRUE;
int fepctrlesc = TRUE;
#endif
int fillcol = 60;
int fkmode = TRUE;
int forceproc = TRUE;
#ifndef B_ACOUNT
int gacount = 256;
#endif
int gasave = 256;
int gbcolor = 9;
#ifndef MINES
int gflags = GFREAD;
#endif
int gmode = 0;
int hjump = 8;
int hscroll = TRUE;
#ifndef MINES
int ifsplit = FALSE;
int ignmetacase = FALSE;
#endif
int ignore_backup_suffix = TRUE;
int isearch_last_key = 0;
#ifndef MINES
int isearch_micro = FALSE;
#endif
int issuper = 0;
int kbdmode = STOP;
int kbdrep = 0;
int kused = KBLOCK;
int kused2 = KBLOCK;
int lastkey = 0;
int lbound = 0;
int leftmargin = 0;
#ifndef MINES
int lnumcol = 1;
int lsepcol = 1;
#endif
int macbug = FALSE;
int magical = FALSE;
int makbak = FALSE;
int memrflag = TRUE;
#ifndef MINES
int menu_code = -1;
int menu_cursor = -1;
int menu_frame_color = 0x0d;
int menu_height = -1;
int menu_home_x = -1;
int menu_home_y = -1;
int menu_item_color = -1;
int menu_last_key = 0;
int menu_quickact = TRUE;
int menu_roll = 0;
int menu_select_color = 0x0e;
int menu_width = -1;
#endif
int modeflag = TRUE;
#ifndef MINES
int mouseflag = FALSE;
#endif
int mpresf = FALSE;
int mstore = FALSE;
#ifndef MINES
int mulmax = 20;
int nclicks = 0;
int newscroll = TRUE;
int noglobal = FALSE;
#endif
int nokill = FALSE;
#ifndef MINES
int optswap = FALSE;
int opt1key = 4;
int opt2key = 8;
int pickcurrc = FALSE;
int quickext = FALSE;
#endif
int quotec1 = CTRL | 'Q';
int quotec2 = CTRL | 'V';
int reptc = CTRL | 'U';
#ifndef MINES
int restflag = FALSE;
#endif
int rmagical = FALSE;
int rval = 0;
int saveflag = 0;
#ifndef MINES
int savem = TRUE;
#endif
int seed = 0;
int sgarbf = TRUE;
int shbufsize = 128;
#ifndef MINES
int show_filesize = FALSE;
#endif
int ssave = FALSE;
#ifndef MINES
int sscroll = TRUE;
int sscroll_slow = FALSE;
#endif
int stabsize = 0;
int stabmode = FALSE;
int sterm = CTRL | '[';
int syseval = TRUE;
int syskill = FALSE;
int syskillflg = FALSE;
#ifndef MINES
int tabcol = 1;
#endif
int tabsize = 8;
int timeflag = FALSE;
#ifndef MINES
int tokana = FALSE;
int txtcol = 3;
#endif
int unix_newline = TRUE;
int vbell = 0;
#ifndef MINES
int viscol = 0x82;
int wrapexpand = TRUE;
#endif
int xf1_key = 0;
int xf2_key = SPEC;
int xf3_key = ALTD;
int xf4_key = META;
int xf5_key = 0;
#ifndef MINES
int zcursor = 0;
#endif

#ifndef MINES
int compcase[] =
  {
    FALSE,      /* CMP_BUFFER   */
    FALSE,      /* CMP_C        */
    FALSE,      /* CMP_COMMAND  */
    TRUE,       /* CMP_FILENAME */
    FALSE,      /* CMP_GENERAL  */
    FALSE,      /* CMP_KEYWORD  */
    FALSE,      /* CMP_LATEX    */
    FALSE,      /* CMP_MACRO    */
    FALSE,      /* CMP_MODE     */
    FALSE       /* CMP_VARIABLE */
  };

int quickact[] =
  {
    FALSE,      /* CMP_BUFFER   */
    TRUE,       /* CMP_C        */
    TRUE,       /* CMP_COMMAND  */
    TRUE,       /* CMP_FILENAME */
    TRUE,       /* CMP_GENERAL  */
    TRUE,       /* CMP_KEYWORD  */
    TRUE,       /* CMP_LATEX    */
    TRUE,       /* CMP_MACRO    */
    TRUE,       /* CMP_MODE     */
    TRUE        /* CMP_VARIABLE */
  };
#endif

char _keyword[256] = {
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,     /* 0x0? */
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,     /* 0x1? */
    0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,     /* 0x2? */
    3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 0, 0, 0, 0, 0, 0,     /* 0x3? */
    0, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,     /* 0x4? */
    3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 0, 0, 0, 0, 3,     /* 0x5? */
    0, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,     /* 0x6? */
    3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 0, 0, 0, 0, 0,     /* 0x7? */
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,     /* 0x8? */
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,     /* 0x9? */
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,     /* 0xa? */
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,     /* 0xb? */
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,     /* 0xc? */
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,     /* 0xd? */
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,     /* 0xe? */
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,     /* 0xf? */
};

#ifndef MINES
const char nsupm[] = "---";
#endif
const char errorm[] = "ERROR";
const char modecode[] = "WCLEVOMaADS";
const char *modename[] =
  {
    "WRAP", "C", "LATEX", "EXACT", "VIEW", "OVER",
    "MAGIC", "ASM", "ASAVE", "DIRED", "SHELL"
  };
const char *cname[] =
  {
    "BLACK", "BLUE", "YELLOW", "WHITE",
    "HBLACK", "HBLUE", "HYELLOW", "HWHITE",
    "RBLACK", "RBLUE", "RYELLOW", "RWHITE",
    "HRBLACK", "HRBLUE", "HRYELLOW", "HRWHITE"
  };
const char breakchar[] =
  {
    "@ABCDefghijklmnopqrstuvwxyz"
  };

#else

/*
----------------------------------------
	ϐ̊OQƐ錾
----------------------------------------
*/

extern BUFFER *bheadp, *blistp, *bcompp, *curbp;
extern BUFFER *bdiredp, *bdmarkp;
extern BUFFER *bhisexecp, *bhisenvp, *bhiscmdp, *bhissearchp;
extern BUFFER *bhisargp, *bhisdebugp;
extern BUFFER *bhiscmpbufp, *bhiscmpcp, *bhiscmpcomp, *bhiscmpfnamep;
extern BUFFER *bhiscmpgenp, *bhiscmpmacp, *bhiscmpmodep;
extern BUFFER *bhiscmpvarp, *bhiscmpdnamep;
#ifndef MINES
extern BUFFER *bdictp, *bhiscmplatexp;
#endif
extern KEYTAB *keytab[];
extern LINE *matchline;
extern MC mcpat[], tapcm[];
extern RMC rmcpat[];
extern UVAR *uv_head, *uv_tail;
extern VIDEO **vscreen;
extern WINDOW *curwp, *wheadp;
extern char **ex_agv, **pr_agv, **func_name;
#ifndef MINES
extern char palstr[], palstr2[];
#endif
extern char sres[], comp_gene[], comp_c[];
extern char emacsdir[];
extern char current_dir[];
#ifndef MINES
extern char comp_latex[], latex_env[], help_load_path[];
#endif
extern char ifilename[];
extern char readbuf[];
extern char golabel[], lastmesg[];
#ifndef MINES
extern char trash[];
#endif
extern char dired_current_dir[];
extern char outline[], pat[], rpat[];
extern char tap[], system_temp[];
extern char simple_backup_suffix[];
extern char wrapindentitem[], wrapindenthead[];
extern char bufhook[], inshook[];
extern char readhook[], wraphook[], writehook[];
extern char exithook[], ifilehook[];
#ifndef MINES
extern char cmdhook[], exbhook[], windhook[];
#endif
extern int *kbdptr, curcol, curgoal, currow, dired_mark_num, sccurcol;
extern int malloc_sbrk_unused, malloc_sbrk_used, thisflag;
extern int matchlen, matchoff, mlenold;
extern int sccurline, kbdm[], lastflag;
extern int malloc_rating, malloc_old_rating;
extern int xpos, ypos, ex_agc, pr_agc;
extern int nfuncs, ttrow, ttcol;
extern int taboff, vtcol, vtrow;
extern int updinsf;
extern int LEDmode;
extern long *lndrv_info;
extern char *sysroot;

extern KILL *kbufh;

extern char *execstr;
extern char *fline;
extern char *lastptr;
extern char *patmatch;

extern char dired_cp_cmd[];
extern char dired_ls_cmd[];
extern char dired_mv_cmd[];
extern char dired_rm_cmd[];

#ifndef MINES
extern char std_dict_path[];
#endif

extern char slash;

extern char backnonbreakchar[];
extern char fornonbreakchar[];
extern char dostail[];
extern char ignoreext[];
extern char mlform[];
#ifndef MINES
extern char menu_title[];
extern char menu_exit[];
extern char menu_select[];
extern char texbquote[];
#endif
extern char wrapitem[];

extern int _dump_flag;

extern int *kbdend;
extern int abortc;
#ifndef MINES
extern int addeof;
#endif
extern int asm_indent;
extern int breakmode;
extern int cbufdir;
#ifndef MINES
extern int chigh;
extern int cbold;
#endif
extern int clexec;
extern int cmdarg;
#ifndef MINES
extern int cmdcol;
#endif
extern int cmdstatus;
#ifndef MINES
extern int cmdzencol;
extern int colvis;
extern int comp_sort;
extern int comp_sort_dir;
extern int comp_sort_ext;
extern int comp_sort_ignore_case;
extern int crcol;
#endif
extern int dateflag;
extern int debug_system;
extern int density;
#ifndef MINES
extern int diagflag;
#endif
extern int dired_cd_flag;
extern int dired_ls_name_pos;
extern int discmd;
extern int disinp;
extern int disnum;
extern int dispcr;
extern int distab;
extern int diszen;
#ifndef MINES
extern int dselcol;
extern int edpage;
#endif
extern int eexitflag;
#ifndef MINES
extern int empcol;
extern int ena_hscroll;
extern short ena_wait_vdisp;
extern int ena_zcursor;
extern int english;
#endif
extern int envram;
extern int execlevel;
extern int executinghook;
#ifndef MINES
extern int fepctrl;
extern int fepctrlesc;
#endif
extern int fillcol;
extern int fkmode;
extern int forceproc;
#ifndef B_ACOUNT
extern int gacount;
#endif
extern int gasave;
extern int gbcolor;
#ifndef MINES
extern int gflags;
#endif
extern int gmode;
extern int hjump;
extern int hscroll;
#ifndef MINES
extern int ifsplit;
extern int ignmetacase;
#endif
extern int ignore_backup_suffix;
extern int isearch_last_key;
#ifndef MINES
extern int isearch_micro;
#endif
extern int issuper;
extern int kbdmode;
extern int kbdrep;
extern int kused;
extern int kused2;
extern int lastkey;
extern int lbound;
extern int leftmargin;
#ifndef MINES
extern int lnumcol;
extern int lsepcol;
#endif
extern int macbug;
extern int magical;
extern int makbak;
extern int memrflag;
#ifndef MINES
extern int menu_code;
extern int menu_cursor;
extern int menu_frame_color;
extern int menu_height;
extern int menu_home_x;
extern int menu_home_y;
extern int menu_item_color;
extern int menu_last_key;
extern int menu_quickact;
extern int menu_roll;
extern int menu_select_color;
extern int menu_width;
#endif
extern int modeflag;
#ifndef MINES
extern int mouseflag;
#endif
extern int mpresf;
extern int mstore;
#ifndef MINES
extern int mulmax;
extern int nclicks;
extern int newscroll;
extern int noglobal;
#endif
extern int nokill;
#ifndef MINES
extern int optswap;
extern int opt1key;
extern int opt2key;
extern int pickcurrc;
extern int quickext;
#endif
extern int quotec1;
extern int quotec2;
extern int reptc;
#ifndef MINES
extern int restflag;
#endif
extern int rmagical;
extern int rval;
extern int saveflag;
#ifndef MINES
extern int savem;
#endif
extern int seed;
extern int sgarbf;
extern int shbufsize;
#ifndef MINES
extern int show_filesize;
#endif
extern int ssave;
#ifndef MINES
extern int sscroll;
extern int sscroll_slow;
#endif
extern int stabsize;
extern int stabmode;
extern int sterm;
extern int syseval;
extern int syskill;
extern int syskillflg;
#ifndef MINES
extern int tabcol;
#endif
extern int tabsize;
extern int timeflag;
#ifndef MINES
extern int tokana;
extern int txtcol;
#endif
extern int unix_newline;
extern int vbell;
#ifndef MINES
extern int viscol;
extern int wrapexpand;
#endif
extern int xf1_key;
extern int xf2_key;
extern int xf3_key;
extern int xf4_key;
extern int xf5_key;
#ifndef MINES
extern int zcursor;
#endif

#ifndef MINES
extern int compcase[];
extern int quickact[];
#endif

extern char _keyword[];

#ifndef MINES
extern const char nsupm[];
#endif
extern const char errorm[];
extern const char modecode[];
extern const char *modename[];
extern const char *cname[];
extern const char breakchar[];

#endif /* maindef */

extern BINDLIST bindtab[];

extern UENVAR env_table[];
extern NBIND command_table[];

extern int blink_count;
extern int numfunc, nevars;
extern int issuper, intercept_flag;
extern char font[], font6[], font_h[], exfont[], exfont6[], exfont_h[];
extern char cur_pat[], cur_pat_h[], cur_pat_6x12[];

extern int dir_word_table_top, fnc_word_table_top, c_word_table_top;
extern int dir_word_table_end, fnc_word_table_end, c_word_table_end;

/*
----------------------------------------
	human68.c ϐ̏lݒ
----------------------------------------
*/

#ifdef	human68def

_tinf tinf[MAXMOD] = {
	{ 64, 32, FALSE,  3},
	{ 64, 32, FALSE, -1},
	{ 32, 16, FALSE, -1},
	{ 32, 16, FALSE, -1},
	{ 64, 32, FALSE,  3},
	{ 64, 32, FALSE, -1},
	{ 32, 16, FALSE, -1},
	{ 32, 16, FALSE, -1},
	{ 64, 32, FALSE,  4},
	{ 64, 32, FALSE, -1},
	{ 32, 16, FALSE, -1},
	{ 32, 16, FALSE, -1},
	{ 64, 32, FALSE,  5},
	{ 64, 32, FALSE, -1},
	{ 32, 16, FALSE, -1},
	{ 32, 16, FALSE, -1},
	{ 96, 32,  TRUE,  0},
	{128, 26, FALSE, -1},
	{128, 53, FALSE, -1}
};

_tinf tinf2[MAXMOD] = {
	{ 85, 42, FALSE,  3},
	{ 85, 42, FALSE, -1},
	{ 42, 21, FALSE, -1},
	{ 42, 21, FALSE, -1},
	{ 85, 42, FALSE,  3},
	{ 85, 42, FALSE, -1},
	{ 42, 21, FALSE, -1},
	{ 42, 21, FALSE, -1},
	{ 85, 42, FALSE,  4},
	{ 85, 42, FALSE, -1},
	{ 42, 21, FALSE, -1},
	{ 42, 21, FALSE, -1},
	{ 85, 42, FALSE,  5},
	{ 85, 42, FALSE, -1},
	{ 42, 21, FALSE, -1},
	{ 42, 21, FALSE, -1},
	{128, 42,  TRUE,  0},
	{128, 34, FALSE, -1},
	{128, 70, FALSE, -1}
};

TERM term = {
	NROW,
	NROW - 1,
	NCOL,
	NCOL - 1,
	MARGIN,
	SCRSIZ,
	NPAUSE,
};

#else

extern _tinf tinf[];
extern _tinf tinf2[];
extern TERM term;

#endif /* human68def */
